#include <lib/std.mi>

Function setObjects();

Global Group frameGroup,beatdisplay;
Global Timer refreshEQ;
Global AnimatedLayer beatbarLeft,beatbarRight;
Global int lastBeatLeft,lastBeatRight;
Global Layer watch;
Global Button Toggler;


System.onScriptLoaded() {

  frameGroup = getScriptGroup();
  beatdisplay = frameGroup.findObject("player.normal.display.beatvisualization");
  beatbarLeft = frameGroup.findObject("beatleft");
  beatbarRight = frameGroup.findObject("beatright");
  watch = frameGroup.findObject("player.normal.display.watch");
  Toggler = frameGroup.findObject("beatvisualization");

  lastBeatLeft = 0;
  lastBeatRight = 0;

  refreshEQ = new Timer;
  refreshEQ.setDelay(10);
}

System.onscriptunloading() {
  delete refreshEQ;
}

setObjects() {
  int group_width = frameGroup.getWidth();

  if ( group_width > 480 ) {
    int newXpos = (group_width-60)/2;
    beatdisplay.setXmlParam("x", IntegerToString(newXpos));
    beatdisplay.show();

    if (getPrivateInt("winamp5","BeatDetection",1)) {
      refreshEQ.stop();
      refreshEQ.start();
    } else {
      refreshEQ.stop();
      beatbarLeft.gotoframe(0);
      beatbarRight.gotoframe(0);
    }
  } else {
    beatdisplay.hide();
    refreshEQ.stop();
  }
}

frameGroup.onResize(int x, int y, int w, int h) {
  setObjects();
}

refreshEQ.onTimer() {
  int beatLeft= System.getLeftVuMeter();
  int beatRight= System.getRightVuMeter();

  int frameLeft=beatLeft/16;
  int frameRight=beatRight/16;

  if (frameLeft>14) frameLeft=14;
  if (frameRight>14) frameRight=14;

  if (frameLeft<lastBeatLeft) {
    frameLeft=lastBeatLeft-1;
    if (frameLeft<0) frameLeft=0;
  }

  if (frameRight<lastBeatRight) {
    frameRight=lastBeatRight-1;
    if (frameRight<0) frameRight=0;
  }

  lastBeatLeft=frameLeft;
  lastBeatRight=frameRight;

  beatbarLeft.gotoframe(frameLeft);
  beatbarRight.gotoframe(frameRight);
}

watch.onSetVisible(Boolean showme) {
  setObjects();
}

Toggler.onLeftClick() {
  GuiObject BeatCheckbox=frameGroup.findObject("check.BeatDetection");
  Layer watch = getscriptgroup().findObject("player.normal.display.watch");
  boolean value=getPrivateInt("winamp5","BeatDetection",1);
  setPrivateInt("winamp5","BeatDetection",!value);

  if (value) {
    watch.hide();
    BeatCheckbox.setXMLParam("default","0");
  } else {
    watch.show();
    BeatCheckbox.setXMLParam("default","1");
  }
  setObjects();
}