#include <lib/std.mi>
#include "attribs.m"

Function SetConfigValue(String item, boolean activ, boolean user);
Function SetBeatWatch(boolean activ);
Function onAttribChanged();

Global Text TxtBox;
Global ToggleButton btnCheckBox;
Global String Item="";
Global String Section="";
Global ConfigAttribute attrib;
Global int defvalue=100;

system.onscriptloaded() {
  initAttribs();
  TxtBox = getscriptgroup().getobject("checkbox.text");
  btnCheckBox = getscriptgroup().getobject("checkbox.toggle");
  attrib = NULL;
}

System.onSetXuiParam(String param, String value) {
  if(strlower(param)=="text") TxtBox.setText(value);
  if(strlower(param)=="cfgitem") Item = value;
  if(strlower(param)=="default") defvalue = stringtointeger(value);

  if (Item != "") {
    if (strlower(item)=="showmenubar") attrib = menubar_main_attrib;
    else if (strlower(item)=="showmenubar_pl") attrib = menubar_pe_attrib;
    else if (strlower(item)=="showmenubar_ml") attrib = menubar_ml_attrib;
    else if (defvalue != 100) SetConfigValue(Item, getPrivateInt("winamp5",Item,defvalue),0);
    if (attrib != NULL) onAttribChanged();
  }
}

onAttribChanged() {
  int activ = StringToInteger(attrib.getData());
  btnCheckBox.setActivated(activ);
}

attrib.onDataChanged() {
  onAttribChanged();
}

btnCheckBox.OnToggle(boolean onoff) {
  if (attrib != NULL) attrib.setData(IntegerToString(onoff));
  else SetConfigValue(Item, onoff,1);
}

TxtBox.onLeftButtonUp(int x, int y) {
  boolean activ = !btnCheckBox.getActivated();
  if (attrib != NULL) attrib.setData(IntegerToString(activ));
  else SetConfigValue(Item, activ,1);
}


SetConfigValue(String item, boolean activ, boolean user) {
  if (attrib == NULL) {
    setPrivateInt("winamp5", Item, activ);
    btnCheckBox.setActivated(activ);
    if (strlower(item)=="beatdetection" && user) SetBeatWatch(activ);
  }
}

SetBeatWatch(boolean activ) {
  Layer watch = getscriptgroup().findObject("player.normal.display.watch");
  if (activ) {
    watch.show();
  } else {
    watch.hide();
  }
}