#include <lib/std.mi>

Function string tokenizeSongInfo(String tkn, String sinfo);
Function getSonginfo();

Global Group frameGroup;
Global GuiObject mono, stereo;
Global Text bitrateText, infolineText, FrequencyText, abrText;
Global Timer songInfoTimer;
Global String SongInfoString;

System.onScriptLoaded(){
	frameGroup = getScriptGroup();
	infolineText = frameGroup.findObject("infoline");

	bitrateText = frameGroup.findObject("Bitrate");
	frequencyText = frameGroup.findObject("Frequency");

	mono = frameGroup.findObject("mono");
	stereo = frameGroup.findObject("stereo");

	songInfoTimer = new Timer;
	songInfoTimer.setDelay(100); // changed to 1000 in onTimer

	mono.hide();
	stereo.hide();

	if (getStatus() == STATUS_PLAYING) {
		getSonginfo();
		songInfoTimer.start();
	} else if (getStatus() == STATUS_PAUSED) {
		getSonginfo();
	}
}

System.onScriptUnloading(){
	delete songInfoTimer;
}

System.onPlay(){
	songInfoTimer.setDelay(100); // changed to 1000 in onTimer
	songInfoTimer.start();
}

System.onStop(){
	songInfoTimer.stop();
	frequencyText.setText("(___)");
	bitrateText.setText("(___)");
	mono.hide();
	stereo.hide();
}

System.onResume(){
	songInfoTimer.start();
}

System.onPause(){
	songInfoTimer.stop();
}

infolineText.onTextChanged(String newtxt) {
	if(newtxt=="-") {
		infolineText.setText("");
		return;
	}
	String tkn, songinfo;
	songinfo = strupper(newtxt);
}

songInfoTimer.onTimer(){
	songInfoTimer.setDelay(1000); 
	getSonginfo();
}

tokenizeSongInfo(String tkn, String sinfo){
	int searchResult;
	String rtn;
	if (tkn=="Bitrate"){
		for (int i = 0; i < 5; i++) {
			rtn = getToken(sinfo, " ", i);
			searchResult = strsearch(rtn, "kbps");
			if (searchResult>0) return Strleft(rtn, 3);
		}
		return "";
	}

	if (tkn=="Channels"){
		for (int i = 0; i < 5; i++) {
			rtn = getToken(sinfo, " ", i);
			searchResult = strsearch(rtn, "tereo");
			if (searchResult>0) return "stereo";
			searchResult = strsearch(rtn, "ono");
			if (searchResult>0) return "mono";
		}
		return "";
	}

	if (tkn=="Frequency"){
		for (int i = 0; i < 5; i++) {
			rtn = getToken(sinfo, " ", i);
			searchResult = strsearch(strlower(rtn), "khz");
			if (searchResult>0) return Strleft(rtn, 2);
		}
		return "";
	}
	else return "";
}

getSonginfo() {
	String tkn;
	SongInfoString = infolineText.getText();

	tkn = tokenizeSongInfo("Bitrate", SongInfoString);
	if(tkn != "") {bitrateText.setText("["+tkn+"]");}

	tkn = tokenizeSongInfo("Channels", SongInfoString);
	if(tkn == "stereo")  {
		stereo.show();
		mono.hide();
	} else {
		mono.show();
		stereo.hide();
	}

	tkn = tokenizeSongInfo("Frequency", SongInfoString);
	if(tkn != "") {frequencyText.setText("["+tkn+"]");}
}