#include <lib/std.mi>

#define MAIN_ATTRIBS_MGR

#include "attribs.m"

#define VIDEO_GUID "{F0816D7B-FFFC-4343-80F2-E8199AA15CC3}"
#define VIS_GUID "{0000000A-000C-0010-FF7B-01014263450C}"

//#define DEBUG

#define FALSE 0
#define TRUE -1

#define CLOSED 0
#define OPEN   1

#define DIRECTION_NONE    0
#define DIRECTION_OPENING 1
#define DIRECTION_CLOSING 2

#define CONTENT_NOTHING 0
#define CONTENT_VIDEO   1
#define CONTENT_VIS     2

#define DETACHED_VIS   1
#define DETACHED_VIDEO 2

Function expandWindow(int withdrawer);
Function reduceWindow(int withdrawer);
Function showWindowContent();
Function HideWindowContent();
Function hideVis();
Function showVis();
Function hideVideo();
Function showVideo();
Function _showVis();
Function _showVideo();
Function _hideVis();
Function _hideVideo();
Function CheckVideo();
Function _showDetachedVis();
Function _showDetachedVideo();
Function showDetachedVis();
Function showDetachedVideo();
Function detachVis();
Function attachVis();
Function detachVideo();
Function attachVideo();
Function openDrawerForVideo();
Function openDrawerForVis();
Function openDrawerForNothing();
Function disablePSOVC();
Function enablePSOVC();

Global Group frameGroup, ButtonsVideo,ButtonsVis,ButtonsVideoDetach,ButtonsVisDetach,ButtonsVideoSwitchto,ButtonsVisSwitchto;
Global Button btnOpen,btnClose,btnMaximize,btnRestore, btnVisDetach, btnVideoDetach, btnVisSwitchto, btnVideoSwitchto;
Global Layout main, shade;
Global Layer resizer,resizerDrawer,OpenCloseHider;

Global Int drawer_direction;

Global Timer callbackTimer;
Global Int callback_vis_show, callback_video_show, callback_vis_hide, callback_video_hide;
Global Timer callbackTimer2;
Global Int callback2_what;
Global Timer PSOVCTimer;
Global Int bypasscancel;
Global Int isinited;

Global Int hiding_video, hiding_vis, showing_vis, showing_video;
Global int oldx,oldy,oldw,oldh,userResize;
Global Int windowshade_openvid;
Global Int windowshade_openvis;

Global GuiObject VideoVisGroup;
Global Int last_forcedbottom, last_forcedtop;
Global Container maincontainer;

System.onScriptLoaded() {
	isinited = 0;

	initAttribs();

	frameGroup = getScriptGroup();
	btnOpen = frameGroup.findObject("videoavs.open");
	btnClose = frameGroup.findObject("videoavs.close");
	btnMaximize = frameGroup.findObject("button.vid.max");
	btnRestore = frameGroup.findObject("button.vid.restore");
	resizer = frameGroup.findObject("player.main.resizer");
	resizerDrawer = frameGroup.findObject("drawer.resizer");

	ButtonsVideo = frameGroup.findObject("buttons.video");
	ButtonsVis = frameGroup.findObject("buttons.vis");

	ButtonsVideoDetach = frameGroup.findObject("buttons.video.detach");
	ButtonsVisDetach = frameGroup.findObject("buttons.vis.detach");
	BtnVisDetach = ButtonsVisDetach.findObject("button.vis.detach");
	BtnVideoDetach = ButtonsVideoDetach.findObject("button.vid.detach");

	ButtonsVideoSwitchto = frameGroup.findObject("buttons.video.switchto");
	ButtonsVisSwitchto = frameGroup.findObject("buttons.vis.switchto");

	BtnVisSwitchto = ButtonsVisSwitchto.findObject("button.vis.Switchto");
	BtnVideoSwitchto = ButtonsVideoSwitchto.findObject("button.vid.Switchto");

	OpenCloseHider=frameGroup.findObject("openclosehider");

	main = frameGroup.getParentLayout();
	maincontainer = main.getContainer();
	VideoVisGroup = frameGroup.findObject("AVSGroup");

	drawer_direction = DIRECTION_NONE;

	VideoVisGroup.hide();
	hideVis();
	hideVideo();

	if (vis_detach_attrib.getData() == "1" && video_detach_attrib.getData() == "1") OpenCloseHider.show();
	else OpenCloseHider.hide();

	oldw=-1;
	userResize=0;

	callbackTimer = new Timer;
	callbackTimer.setDelay(1);
	callbackTimer2 = new Timer;
	callbackTimer2.setDelay(1);
	PSOVCTimer = new Timer;
	PSOVCTimer.setDelay(1000);
}

main.onSetVisible(int show) {
	if (!shade) {
		shade = maincontainer.getLayout("shade");
		if (shade == NULL) DebugString("shade == NULL!", 0); else DebugString("shade is ok", 0);
	}
}

System.onScriptUnloading(){
	delete callbackTimer;
	delete callbackTimer2;
	delete PSOVCTimer;
}

main.onTargetReached() {
	unlockUI();
	if (drawer_directiontop_attrib.getData() =="1") main.reverseTarget(0);
	if (drawer_direction == DIRECTION_OPENING) {
		showWindowContent();
		setPrivateInt("winamp5", "VideoAVSOpenState", OPEN);
	} else if (drawer_direction == DIRECTION_CLOSING) {
		VideoVisGroup.hide();
		setPrivateInt("winamp5", "VideoAVSOpenState", CLOSED);
	}
	drawer_direction = DIRECTION_NONE;
}

expandWindow(int withdrawer) {
#ifdef DEBUG
	debugstring("expand - curstate = " + integertostring(getPrivateInt("winamp5", "VideoAVSOpenState", CLOSED)), 0);
#endif
	setPrivateInt("winamp5", "VideoAVSOpenState", OPEN);
	int h=getPrivateInt("winamp5", "VideoAVSHeight", 510);
	if (h == 280) h = 510;
	int w = main.getGuiW();

	if (h == main.getHeight()) withdrawer = 0;

	resizer.setXmlParam("resize", "bottomright");
	resizerDrawer.setXmlParam("resize", "bottomright");
	btnOpen.hide();
	main.setXmlParam("minimum_h", "380");

	int fromtop=0;
	if (drawer_directiontop_attrib.getData() =="1") fromtop = 1;

	int delay = 0;
	if (withdrawer && StringToInteger(scrolldrawerattrib.getData())) delay = 1;

	if (drawer_directionbypass_attrib.getData() == "1") {
		last_forcedbottom = 0;
		last_forcedtop = 0;
		// clienttoscreen auto adjusts for render ratio
		if (fromtop) {
			int y = main.getGuiY();
			int curh = main.clientToScreenH(main.getGuiH());
			if (y + curh < main.clientToScreenH(h) + getViewportTop()) {
				fromtop = 0;
				last_forcedbottom = 1;
			}
		} else {
			int offset = 0;
			if (!getPrivateInt("winamp5", "DrawerOpen", 0)) offset = 116;
			int y = main.getGuiY();
			if (y + main.clientToScreenH(h-offset) > getViewPortTop()+getViewPortHeight()) {
				fromtop = 1;
				last_forcedtop = 1;
			}
		}
	}

	drawer_direction = DIRECTION_OPENING;
	main.setTargetX(main.getGuiX());
	main.setTargetY(main.getGuiY());
	main.setTargetW(w);
        main.setTargetH(h);
	main.reverseTarget(fromtop);
	main.setTargetSpeed(delay);
        main.gotoTarget();
	lockUI();

/* old way
	unlockUI();
	main.cancelTarget();
	int x=main.getLeft();
	int y;
	if (fromtop) y=main.getTop() - (h-280);
	else y = main.getTop();
	int w=main.getWidth();
	main.resize(x, y, w, h);
	showWindowContent();
*/

	setPrivateInt("winamp5", "VideoAVSHeight", h);
	VideoVisGroup.show();
}

reduceWindow(int withdrawer) {
#ifdef DEBUG
	debugstring("reduce", 0);
#endif
	hideVis();
	hideVideo();
	setPrivateInt("winamp5", "VideoAVSOpenState", CLOSED);
	if (drawer_direction == DIRECTION_NONE) { // avoid saving new size if we're currenly opening
		int h=main.getHeight();
		setPrivateInt("winamp5", "VideoAVSHeight", h);
	}

	resizer.setXmlParam("resize", "right");
	resizerDrawer.setXmlParam("resize", "right");
	btnOpen.show();

	hideWindowContent();

	int fromtop=0;
	if (drawer_directiontop_attrib.getData() =="1") fromtop = 1;

	main.setXmlParam("minimum_h", "280");

	int delay = 0;
	if (withdrawer && StringToInteger(scrolldrawerattrib.getData())) delay = 1;

	if (drawer_directionbypass_attrib.getData() == "1") {
		if (last_forcedtop) fromtop = 1;
		if (last_forcedbottom) fromtop = 0;
	}

	drawer_direction = DIRECTION_CLOSING;
	main.setTargetX(main.getGuiX());
	main.setTargetY(main.getGuiY());
	main.setTargetW(main.getGuiW());
        main.setTargetH(280);
	main.reverseTarget(fromtop);
	main.setTargetSpeed(delay);
	main.gotoTarget();
	lockUI();

/* old way
	unlockUI();
	main.cancelTarget();
	int x=main.getLeft();
	int y;
	if (fromtop) y = main.getTop() + (main.getHeight()-280);
	else y = main.getTop();
	int w=main.getWidth();
	main.resize(x, y, w, 280);
	VideoVisGroup.hide();
*/

}

btnOpen.onLeftClick() {
  int s = getStatus();
  if (s == STATUS_PLAYING || s == STATUS_PAUSED) {
    if (!isVideo()) {
      if (vis_detach_attrib.getData() == "0") {
        openDrawerForVis();
      } else if (video_detach_attrib.getData() == "0") {
        openDrawerForVideo();
      } else {
        openDrawerForNothing();
      }
    } else {
      if (video_detach_attrib.getData() == "0") {
        openDrawerForVideo();
      } else if (vis_detach_attrib.getData() == "0") {
        openDrawerForVis();
      } else {
        openDrawerForNothing();
      }
    }
  } else {
    int Window_Content=getPrivateInt("winamp5", "VideoAVSState", CONTENT_VIS);
    if (window_content == CONTENT_VIS && vis_detach_attrib.getData() == "0") {
      openDrawerForVis();
    } else if (window_content == CONTENT_VIDEO && video_detach_attrib.getData() == "0") {
      openDrawerForVideo();
    } else if (vis_detach_attrib.getData() == "0") {
      openDrawerForVis();
    } else if (video_detach_attrib.getData() == "0") {
      openDrawerForVideo();
    } else {
      openDrawerForNothing();
    }
  }
}

btnClose.onLeftClick() {
	reduceWindow(1);
}

System.onGetCancelComponent(String guid, boolean goingvisible) {
#ifdef DEBUG
	DebugString("+", 0);
#endif
	if (bypasscancel) return FALSE;
	if (guid == VIDEO_GUID && !goingvisible && hiding_video) return FALSE;
	if (guid == VIS_GUID && !goingvisible && hiding_vis) return FALSE;
	if (guid == VIDEO_GUID && goingvisible && showing_video) return FALSE;
	if (guid == VIS_GUID && goingvisible && showing_vis) return FALSE;

#ifdef DEBUG
	DebugString("--------------- onGetCancelComponent ----------------", 0);
	DebugString(" GUID : " + guid, 0);
	if (goingvisible) DebugString(" Going Visible", 0); else DebugString(" Going Invisible", 0);
	DebugString(" Last Content : " + IntegerToString(getPrivateInt("winamp5", "VideoAVSState", CONTENT_VIS)), 0);
	DebugString(" Drawer State : " + IntegerToString(getPrivateInt("winamp5", "VideoAVSOpenState", CLOSED)), 0);
	DebugString("-----------------------------------------------------", 0);
#endif

	if (!main.isVisible()) return FALSE;

	int Window_Content=getPrivateInt("winamp5", "VideoAVSState", CONTENT_VIS);
	int window_status =getPrivateInt("winamp5", "VideoAVSOpenState", CLOSED);

	if (window_status == CLOSED) {
		if (guid == VIDEO_GUID) {
			if (video_detach_attrib.getData() == "0") {
				if (goingvisible) {
					openDrawerForVideo();
					return TRUE;
				}
			}
		}
		if (guid == VIS_GUID) {
			if (vis_detach_attrib.getData() == "0") {
				if (goingvisible) {
					openDrawerForVis();
					return TRUE;
				}
			}
		}
	} else if (window_status == OPEN) {
		if (goingvisible) {
			if (guid == VIDEO_GUID && window_content == CONTENT_VIS) {
				if (video_detach_attrib.getData() == "0") {
					window_content = CONTENT_VIDEO;
					hideVis();
					_showVideo();
					return TRUE;
				}
			} else if (guid == VIS_GUID && window_content == CONTENT_VIDEO) {
				if (vis_detach_attrib.getData() == "0") {
					window_content = CONTENT_VIS;
					disablePSOVC();
					hideVideo();
					_showVis();
					return TRUE;
				}
			}
		}
	}
	if (!goingvisible && window_status == OPEN) {
#ifdef DEBUG
		DebugString("closing " + guid, 0);
#endif
		if (guid == VIDEO_GUID && window_content == CONTENT_VIDEO) {
			hideVideo();
			reduceWindow(1);
			return FALSE;
		}
		if (guid == VIS_GUID && window_content == CONTENT_VIS) {
			hideVis();
			if ((getStatus() == STATUS_PLAYING ||
			     getStatus() == STATUS_PAUSED) &&
			     isVideo() &&
			     video_detach_attrib.getData() == "0") {
				_showVideo();
			} else {
				reduceWindow(1);
			}
			return FALSE;
		}
	}
#ifdef DEBUG
	DebugString("Went thru", 0);
#endif
	return FALSE;
}

callbackTimer.onTimer() {
	stop();
	int cvds = callback_video_show;
	int cvss = callback_vis_show;
	int cvdh = callback_video_hide;
	int cvsh = callback_vis_hide;
	callback_video_show = 0;
	callback_vis_show = 0;
	callback_video_hide = 0;
	callback_vis_hide = 0;
	if (cvds == 1) showVideo();
	if (cvss == 1) showVis();
	if (cvsh == 1) hideVis();
	if (cvdh == 1) hideVideo();
}

_showVideo() {
	callback_video_show = 1;
	callback_video_hide = 0;
	callbackTimer.start();
}

_showVis() {
	callback_vis_show = 1;
	callback_vis_hide = 0;
	callbackTimer.start();
}

_hideVideo() {
	callback_video_show = 0;
	callback_video_hide = 1;
	callbackTimer.start();
}

_hideVis() {
	callback_vis_show = 0;
	callback_vis_hide = 1;
	callbackTimer.start();
}

showVis() {
#ifdef DEBUG
	DebugString("showvis",0 );
#endif
	showing_vis = 1;
	setPrivateInt("winamp5", "VideoAVSOpenState", OPEN);
	setPrivateInt("winamp5", "VideoAVSState", CONTENT_VIS);
	GuiObject o = getScriptGroup().findObject("myviswnd");
	if (o != NULL) { bypasscancel = 1; o.show(); bypasscancel = 0; }
#ifdef DEBUG
	else DebugString("vis object not found (show)", 0);
#endif
	ButtonsVideo.hide();
	ButtonsVideoDetach.hide();
	ButtonsVideoSwitchto.hide();
	ButtonsVis.show();
	ButtonsVisDetach.show();
	if (video_detach_attrib.getData() == "0") ButtonsVisSwitchto.show();
	showing_vis = 0;
}

hideVis() {
	callback_vis_show = 0;
#ifdef DEBUG
	DebugString("hidevis",0 );
#endif
	hiding_vis = 1;
	GuiObject o = getScriptGroup().findObject("myviswnd");
	if (o != NULL) { bypasscancel = 1; o.hide(); bypasscancel = 0; }
#ifdef DEBUG
	else DebugString("video object not found (hide)", 0);
#endif
	ButtonsVis.hide();
	ButtonsVisDetach.hide();
	ButtonsVisSwitchto.hide();

	hiding_vis = 0;
}

showVideo() {
#ifdef DEBUG
	DebugString("showvideo",0 );
#endif
	showing_video = 1;
	setPrivateInt("winamp5", "VideoAVSOpenState", OPEN);
	setPrivateInt("winamp5", "VideoAVSState", CONTENT_VIDEO);
	GuiObject o = getScriptGroup().findObject("myvideownd");
	if (o != NULL) { bypasscancel = 1; o.show(); bypasscancel = 0; }
#ifdef DEBUG
	else DebugString("vis object not found (show)", 0);
#endif
	ButtonsVis.hide();
	ButtonsVisDetach.hide();
	ButtonsVisSwitchto.hide();
	ButtonsVideo.show();
	ButtonsVideoDetach.show();
	if (vis_detach_attrib.getData() == "0") ButtonsVideoSwitchto.show();
	showing_video = 0;
}

hideVideo() {
	callback_video_show = 0;
#ifdef DEBUG
	DebugString("hidevideo",0 );
#endif
	hiding_video = 1;
	GuiObject o = getScriptGroup().findObject("myvideownd");
	if (o != NULL) { bypasscancel = 1; o.hide(); bypasscancel = 0; }
#ifdef DEBUG
	else DebugString("video object not found (hide)", 0);
#endif
	ButtonsVideo.hide();
	ButtonsVideoDetach.hide();
	ButtonsVideoSwitchto.hide();
	hiding_video = 0;
}

showWindowContent() {
	int lastWindowContent=getPrivateInt("winamp5", "VideoAVSState", 2);
#ifdef DEBUG
	DebugString("showWindowContent = " + IntegerToString(lastWindowContent), 0);
#endif
	if (lastWindowContent==CONTENT_VIDEO) _showVideo();
	if (lastWindowContent==CONTENT_VIS) _showVis();
}


hideWindowContent() {
	int lastWindowContent=getPrivateInt("winamp5", "VideoAVSState", 2);
#ifdef DEBUG
	DebugString("hideWindowContent = " + IntegerToString(lastWindowContent), 0);
#endif
	/*if (lastWindowContent==CONTENT_VIDEO)*/ hideVideo();
	/*if (lastWindowContent==CONTENT_VIS)*/ hideVis();
}


btnMaximize.onLeftClick() {

	oldx=main.getGuiX();
	oldy=main.getGuiY();
	oldw=main.getGuiW();
	oldh=main.getGuiH();

	btnRestore.show();
	btnMaximize.hide();

	int vx=getViewportLeft();
	int vy=getViewportTop();
	int vw=getViewportWidth();
	int vh=getViewportHeight();

	userResize=1;

	main.resize(vx, vy, vw, vh+119);
}

btnRestore.onLeftClick() {
	btnMaximize.show();
	btnRestore.hide();

	main.resize(oldx, oldy, oldw, oldh);
}

OpenDrawerForVideo() {
  setPrivateInt("winamp5", "VideoAVSState", CONTENT_VIDEO);
  expandWindow(1);
}

OpenDrawerForVis() {
  setPrivateInt("winamp5", "VideoAVSState", CONTENT_VIS);
  expandWindow(1);
}

OpenDrawerForNothing() {
  setPrivateInt("winamp5", "VideoAVSState", CONTENT_NOTHING);
  expandWindow(1);
}

main.onResize(int x, int y, int w, int h) {
	if (!userResize) {
		btnMaximize.show();
		btnRestore.hide();
	}
	userResize=0;

	if (!main.isGoingToTarget() && !isinited) {
		isinited = 1;
		if (h > 280) { setPrivateInt("winamp5", "VideoAVSOpenState", OPEN); expandWindow(0); }
        	else setPrivateInt("winamp5", "VideoAVSOpenState", CLOSED);
	}
}

BtnVisDetach.onLeftClick() {
  vis_detach_attrib.setData("1");
}

BtnVideoDetach.onLeftClick() {
  video_detach_attrib.setData("1");
}

BtnVisSwitchto.onLeftClick() {
	hideVis();
	showVideo();
}

BtnVideoSwitchto.onLeftClick() {
	disablePSOVC();
	hideVideo();
	showVis();
}

video_detach_attrib.onDataChanged() {
#ifdef DEBUG
  DebugString("detach video changed", 0);
#endif
  if (getData() == "1") {
		detachVideo();
		ButtonsVisSwitchto.hide();
		if (vis_detach_attrib.getData() == "1") OpenCloseHider.show();
	} else {
		if (getData() == "0") {
			attachVideo();
			ButtonsVisSwitchto.show();
			OpenCloseHider.hide();
		}
	}
}

vis_detach_attrib.onDataChanged() {
#ifdef DEBUG
  DebugString("detach vis changed", 0);
#endif
  if (getData() == "1") {
		detachVis();
		ButtonsVideoSwitchto.hide();
		if (video_detach_attrib.getData() == "1") OpenCloseHider.show();
	} else {
		if (getData() == "0") {
			attachVis();
			ButtonsVideoSwitchto.show();
			OpenCloseHider.hide();
		}
	}
}

detachVideo() {
  int wasvisible = isNamedWindowVisible(VIDEO_GUID);
  int lastWindowContent=getPrivateInt("winamp5", "VideoAVSState", 2);
  int window_status =getPrivateInt("winamp5", "VideoAVSOpenState", CLOSED);
  if (!wasvisible) return;
  if (lastWindowContent != CONTENT_VIDEO) return;
  if (window_status == OPEN) {
    disablePSOVC();
    reduceWindow(1);
  }
  _showDetachedVideo();
}

detachVis() {
  int lastWindowContent=getPrivateInt("winamp5", "VideoAVSState", 2);
  int window_status =getPrivateInt("winamp5", "VideoAVSOpenState", CLOSED);
  if (lastWindowContent != CONTENT_VIS) return;
  int wasvisible = isNamedWindowVisible(VIS_GUID);
  if (!wasvisible) return;
  if (window_status == OPEN) {
    hideVis();
    if ((getStatus() == STATUS_PLAYING ||
       getStatus() == STATUS_PAUSED) && isVideo() &&
       video_detach_attrib.getData() == "0") {
	  setPrivateInt("winamp5", "VideoAVSState", CONTENT_VIDEO);
  	_showVideo();
    } else {
      reduceWindow(1);
    }
  }
  _showDetachedVis();
}

attachVideo() {
  disablePSOVC();
  int wasvisible = isNamedWindowVisible(VIDEO_GUID);
  if (wasvisible) {
    hideNamedWindow(VIDEO_GUID);
    int window_status =getPrivateInt("winamp5", "VideoAVSOpenState", CLOSED);
    int window_content=getPrivateInt("winamp5", "VideoAVSState", 2);
    if (window_content == CONTENT_VIS) hideVis();
    if (window_status == CLOSED) openDrawerForVideo();
    else _showVideo();
  }
}

attachVis() {
  disablePSOVC();
  int wasvisible = isNamedWindowVisible(VIS_GUID);
  if (wasvisible) {
    hideNamedWindow(VIS_GUID);
    int window_status =getPrivateInt("winamp5", "VideoAVSOpenState", CLOSED);
    int window_content=getPrivateInt("winamp5", "VideoAVSState", 2);
    if (window_content == CONTENT_VIDEO) hideVideo();
    if (window_status == CLOSED) openDrawerForVis();
    else _showVis();
  }
}

callbackTimer2.onTimer() {
	stop();
	if (callback2_what == DETACHED_VIDEO) showDetachedVideo();
	if (callback2_what == DETACHED_VIS) showDetachedVis();
}

_showDetachedVis() {
	callback2_what = DETACHED_VIS;
	callbackTimer2.start();
}

_showDetachedVideo() {
	callback2_what = DETACHED_VIDEO;
	callbackTimer2.start();
}

showDetachedVis() {
#ifdef DEBUG
  DebugString("show detached vis",0 );
#endif
  showWindow(VIS_GUID, "", 0);
}

showDetachedVideo() {
#ifdef DEBUG
  DebugString("show detached video",0 );
#endif
  showWindow(VIDEO_GUID, "", 0);
  enablePSOVC();
}

disablePSOVC() {
#ifdef DEBUG
  DebugString("disabling stop on video close",0 );
#endif
	ConfigItem item = Config.getItem(SKINTWEAKS_CFGPAGE);
	if (item) {
		ConfigAttribute attr = item.getAttribute("Prevent video playback Stop on video window Close");
		if (attr) attr.setData("1");
	}
	psovctimer.start();
}

enablePSOVC() {
#ifdef DEBUG
  DebugString("enabling stop on video close",0 );
#endif
	psovctimer.stop();
	ConfigItem item = Config.getItem(SKINTWEAKS_CFGPAGE);
	if (item) {
		ConfigAttribute attr = item.getAttribute("Prevent video playback Stop on video window Close");
		if (attr) attr.setData("0");
	}
}

PSOVCTimer.onTimer() {
	enablePSOVC();
}

main.onUserResize(int x, int y, int w, int h) {
  int window_status=getPrivateInt("winamp5", "VideoAVSOpenState", CLOSED);
  if (window_status == OPEN) {
	int h = getHeight();
	if (h != 280) {
		DebugString("h = "+integerTostring(h), 0);
		setPrivateInt("winamp5", "VideoAVSHeight", h);
	}
  }
}

maincontainer.onBeforeSwitchToLayout(Layout oldl, Layout newl) {
  int window_status =getPrivateInt("winamp5", "VideoAVSOpenState", CLOSED);
  int window_content=getPrivateInt("winamp5", "VideoAVSState", 2);
  if (oldl == main && window_status == OPEN && window_content == CONTENT_VIDEO && getStatus() == STATUS_PLAYING && isVideo()) {
    disablePSOVC();
    windowshade_openvid = 1;
  }
  if (oldl == main && window_status == OPEN && window_content == CONTENT_VIS) {
    windowshade_openvis = 1;
  }
}

maincontainer.onSwitchToLayout(Layout newl) {
  // these do not call detachVis or detachVideo but showDetachVis and showDetachVideo so that the change is temporary
  if (windowshade_openvid) {
    windowshade_openvid = 0;
    showDetachedVideo(); 
  }
  if (windowshade_openvis) {
    windowshade_openvis = 0;
    showDetachedVis(); 
  }
}

